#include <vxWorks.h>
#include <semLib.h>
#include "ellLib.h"
#include "fast_lock.h"
#include "link.h"
#include "tsDefs.h"

#ifndef INCdxpYNH
#define INCdxpYNH
typedef enum {
	dxpYN_No,
	dxpYN_Yes
}dxpYN;
#endif /*INCdxpYNH*/

#ifndef INCdxpPLRTH
#define INCdxpPLRTH
typedef enum {
	dxpPLRT_Negative,
	dxpPLRT_Positive
}dxpPLRT;
#endif /*INCdxpPLRTH*/

#ifndef INCdxpCALH
#define INCdxpCALH
typedef enum {
	dxpCAL_TRACKRST,
	dxpCAL_DACPERADC
}dxpCAL;
#endif /*INCdxpCALH*/
#ifndef INCdxpH
#define INCdxpH
typedef struct dxpRecord {
	char		name[29]; /*Record Name*/
	char		desc[29]; /*Descriptor*/
	char		asg[29]; /*Access Security Group*/
	unsigned short	scan;	/*Scan Mechanism*/
	unsigned short	pini;	/*Process at iocInit*/
	short		phas;	/*Scan Phase*/
	short		evnt;	/*Event Number*/
	short		tse;	/*Time Stamp Event*/
	DBLINK		tsel;	/*Time Stamp Link*/
	unsigned short	dtyp;	/*Device Type*/
	short		disv;	/*Disable Value*/
	short		disa;	/*Disable*/
	DBLINK		sdis;	/*Scanning Disable*/
	FAST_LOCK	mlok;	/*Monitor fastlock*/
	ELLLIST		mlis;	/*Monitor List*/
	unsigned char	disp;	/*Disable putField*/
	unsigned char	proc;	/*Force Processing*/
	unsigned short	stat;	/*Alarm Status*/
	unsigned short	sevr;	/*Alarm Severity*/
	unsigned short	nsta;	/*New Alarm Status*/
	unsigned short	nsev;	/*New Alarm Severity*/
	unsigned short	acks;	/*Alarm Ack Severity*/
	unsigned short	ackt;	/*Alarm Ack Transient*/
	unsigned short	diss;	/*Disable Alarm Sevrty*/
	unsigned char	lcnt;	/*Lock Count*/
	unsigned char	pact;	/*Record active*/
	unsigned char	putf;	/*dbPutField process*/
	unsigned char	rpro;	/*Reprocess */
	void		*asp;	/*Access Security Pvt*/
	struct putNotify *ppn;	/*addr of PUTNOTIFY*/
	struct pnWaitNode *ppnn;	/*next record PUTNOTIFY*/
	struct scan_element *spvt;	/*Scan Private*/
	struct rset	*rset;	/*Address of RSET*/
	struct dset	*dset;	/*DSET address*/
	void		*dpvt;	/*Device Private*/
	struct dbRecordType *rdes;	/*Address of dbRecordType*/
	struct lockRecord *lset;	/*Lock Set*/
	unsigned short	prio;	/*Scheduling Priority*/
	unsigned char	tpro;	/*Trace Processing*/
	char bkpt;	/*Break Point*/
	unsigned char	udf;	/*Undefined*/
	TS_STAMP	time;	/*Time*/
	DBLINK		flnk;	/*Forward Process Link*/
	long		val;	/*Current value*/
	unsigned short *bptr;	/*Baseline Buffer Pointer*/
	short		base;	/*Baseline Histogram*/
	unsigned short *pptr;	/*Parameter Buffer Pointer*/
	short		parm;	/*DXP Parameters*/
	long		mtyp;	/*Module type*/
	unsigned short	a01v;	/*A01V*/
	char		a01l[16]; /*A01V label*/
	short		a01o;	/*A01V offset*/
	short		a02v;	/*A02V*/
	char		a02l[16]; /*A02V label*/
	short		a02o;	/*A02V offset*/
	short		a03v;	/*A03V*/
	char		a03l[16]; /*A02V label*/
	short		a03o;	/*A02V offset*/
	short		a04v;	/*A04V*/
	char		a04l[16]; /*A04V label*/
	short		a04o;	/*A04V offset*/
	short		a05v;	/*A05V*/
	char		a05l[16]; /*A05V label*/
	short		a05o;	/*A05V offset*/
	short		a06v;	/*A06V*/
	char		a06l[16]; /*A06V label*/
	short		a06o;	/*A06V offset*/
	short		a07v;	/*A07V*/
	char		a07l[16]; /*A07V label*/
	short		a07o;	/*A07V offset*/
	short		a08v;	/*A08V*/
	char		a08l[16]; /*A08V label*/
	short		a08o;	/*A08V offset*/
	short		a09v;	/*A09V*/
	char		a09l[16]; /*A09V label*/
	short		a09o;	/*A09V offset*/
	short		f01v;	/*F01V*/
	char		f01l[16]; /*F01V label*/
	short		f01o;	/*F01V offset*/
	short		f02v;	/*F02V*/
	char		f02l[16]; /*F02V label*/
	short		f02o;	/*F02V offset*/
	short		f03v;	/*F03V*/
	char		f03l[16]; /*F03V label*/
	short		f03o;	/*F03V offset*/
	short		f04v;	/*F04V*/
	char		f04l[16]; /**/
	short		f04o;	/**/
	short		f05v;	/**/
	char		f05l[16]; /**/
	short		f05o;	/**/
	short		f06v;	/**/
	char		f06l[16]; /**/
	short		f06o;	/**/
	short		f07v;	/**/
	char		f07l[16]; /**/
	short		f07o;	/**/
	short		f08v;	/**/
	char		f08l[16]; /**/
	short		f08o;	/**/
	short		f09v;	/**/
	char		f09l[16]; /**/
	short		f09o;	/**/
	short		f10v;	/**/
	char		f10l[16]; /**/
	short		f10o;	/**/
	short		d01v;	/**/
	char		d01l[16]; /**/
	short		d01o;	/**/
	short		d02v;	/**/
	char		d02l[16]; /**/
	short		d02o;	/**/
	short		d03v;	/**/
	char		d03l[16]; /**/
	short		d03o;	/**/
	short		d04v;	/**/
	char		d04l[16]; /**/
	short		d04o;	/**/
	short		d05v;	/**/
	char		d05l[16]; /**/
	short		d05o;	/**/
	short		d06v;	/**/
	char		d06l[16]; /**/
	short		d06o;	/**/
	short		d07v;	/**/
	char		d07l[16]; /**/
	short		d07o;	/**/
	short		d08v;	/**/
	char		d08l[16]; /**/
	short		d08o;	/**/
	short		d09v;	/**/
	char		d09l[16]; /**/
	short		d09o;	/**/
	short		d10v;	/**/
	char		d10l[16]; /**/
	short		d10o;	/**/
	short		b01v;	/**/
	char		b01l[16]; /**/
	short		b01o;	/**/
	short		b02v;	/**/
	char		b02l[16]; /**/
	short		b02o;	/**/
	short		b03v;	/**/
	char		b03l[16]; /**/
	short		b03o;	/**/
	short		b04v;	/**/
	char		b04l[16]; /**/
	short		b04o;	/**/
	short		b05v;	/**/
	char		b05l[16]; /**/
	short		b05o;	/**/
	short		b06v;	/**/
	char		b06l[16]; /**/
	short		b06o;	/**/
	short		r01v;	/**/
	char		r01l[16]; /**/
	short		r01o;	/**/
	short		r02v;	/**/
	char		r02l[16]; /**/
	short		r02o;	/**/
	short		r03v;	/**/
	char		r03l[16]; /**/
	short		r03o;	/**/
	short		r04v;	/**/
	char		r04l[16]; /**/
	short		r04o;	/**/
	short		r05v;	/**/
	char		r05l[16]; /**/
	short		r05o;	/**/
	short		r06v;	/**/
	char		r06l[16]; /**/
	short		r06o;	/**/
	short		r07v;	/**/
	char		r07l[16]; /**/
	short		r07o;	/**/
	short		r08v;	/**/
	char		r08l[16]; /**/
	short		r08o;	/**/
	short		r09v;	/**/
	char		r09l[16]; /**/
	short		r09o;	/**/
	short		r10v;	/**/
	char		r10l[16]; /**/
	short		r10o;	/**/
	short		r11v;	/**/
	char		r11l[16]; /**/
	short		r11o;	/**/
	short		r12v;	/**/
	char		r12l[16]; /**/
	short		r12o;	/**/
	short		r13v;	/**/
	char		r13l[16]; /**/
	short		r13o;	/**/
	short		r14v;	/**/
	char		r14l[16]; /**/
	short		r14o;	/**/
	short		r15v;	/**/
	char		r15l[16]; /**/
	short		r15o;	/**/
	long		s01v;	/**/
	char		s01l[16]; /**/
	short		s01o;	/**/
	long		s02v;	/**/
	char		s02l[16]; /**/
	short		s02o;	/**/
	long		s03v;	/**/
	char		s03l[16]; /**/
	short		s03o;	/**/
	long		s04v;	/**/
	char		s04l[16]; /**/
	short		s04o;	/**/
	long		s05v;	/**/
	char		s05l[16]; /**/
	short		s05o;	/**/
	long		s06v;	/**/
	char		s06l[16]; /**/
	short		s06o;	/**/
	long		s07v;	/*Livetime*/
	char		s07l[16]; /**/
	short		s07o;	/**/
	long		s08v;	/**/
	char		s08l[16]; /**/
	short		s08o;	/**/
	long		s09v;	/**/
	char		s09l[16]; /**/
	short		s09o;	/**/
	long		s10v;	/**/
	char		s10l[16]; /**/
	short		s10o;	/**/
	long		s11v;	/**/
	char		s11l[16]; /**/
	short		s11o;	/**/
	long		s12v;	/**/
	char		s12l[16]; /**/
	short		s12o;	/**/
	long		s13v;	/**/
	char		s13l[16]; /**/
	short		s13o;	/**/
	long		s14v;	/**/
	char		s14l[16]; /**/
	short		s14o;	/**/
	long		strt;	/*Start acquiring*/
	long		stop;	/*Stop acquiring*/
	long		eras;	/*Erase*/
	unsigned short	t01v;	/**/
	char		t01l[25]; /**/
	unsigned short	t02v;	/**/
	char		t02l[25]; /**/
	unsigned short	t03v;	/**/
	char		t03l[25]; /**/
	unsigned short	t04v;	/**/
	char		t04l[25]; /**/
	unsigned short	t05v;	/**/
	char		t05l[25]; /**/
	unsigned short	t06v;	/**/
	char		t06l[25]; /**/
	unsigned short	t07v;	/**/
	char		t07l[25]; /**/
	unsigned short	t08v;	/**/
	char		t08l[25]; /**/
	unsigned short	t09v;	/**/
	char		t09l[25]; /**/
	unsigned short	t10v;	/**/
	char		t10l[25]; /**/
	unsigned short	t11v;	/**/
	char		t11l[25]; /**/
	unsigned short	rcal;	/*Run calibration*/
	unsigned short	calr;	/*Calibration routine*/
	unsigned short	pktm;	/*Peaking time*/
	char *pkl;	/*Peak label pointer*/
	DBLINK		inp;	/*Input specification*/
} dxpRecord;
#define dxpRecordNAME	0
#define dxpRecordDESC	1
#define dxpRecordASG	2
#define dxpRecordSCAN	3
#define dxpRecordPINI	4
#define dxpRecordPHAS	5
#define dxpRecordEVNT	6
#define dxpRecordTSE	7
#define dxpRecordTSEL	8
#define dxpRecordDTYP	9
#define dxpRecordDISV	10
#define dxpRecordDISA	11
#define dxpRecordSDIS	12
#define dxpRecordMLOK	13
#define dxpRecordMLIS	14
#define dxpRecordDISP	15
#define dxpRecordPROC	16
#define dxpRecordSTAT	17
#define dxpRecordSEVR	18
#define dxpRecordNSTA	19
#define dxpRecordNSEV	20
#define dxpRecordACKS	21
#define dxpRecordACKT	22
#define dxpRecordDISS	23
#define dxpRecordLCNT	24
#define dxpRecordPACT	25
#define dxpRecordPUTF	26
#define dxpRecordRPRO	27
#define dxpRecordASP	28
#define dxpRecordPPN	29
#define dxpRecordPPNN	30
#define dxpRecordSPVT	31
#define dxpRecordRSET	32
#define dxpRecordDSET	33
#define dxpRecordDPVT	34
#define dxpRecordRDES	35
#define dxpRecordLSET	36
#define dxpRecordPRIO	37
#define dxpRecordTPRO	38
#define dxpRecordBKPT	39
#define dxpRecordUDF	40
#define dxpRecordTIME	41
#define dxpRecordFLNK	42
#define dxpRecordVAL	43
#define dxpRecordBPTR	44
#define dxpRecordBASE	45
#define dxpRecordPPTR	46
#define dxpRecordPARM	47
#define dxpRecordMTYP	48
#define dxpRecordA01V	49
#define dxpRecordA01L	50
#define dxpRecordA01O	51
#define dxpRecordA02V	52
#define dxpRecordA02L	53
#define dxpRecordA02O	54
#define dxpRecordA03V	55
#define dxpRecordA03L	56
#define dxpRecordA03O	57
#define dxpRecordA04V	58
#define dxpRecordA04L	59
#define dxpRecordA04O	60
#define dxpRecordA05V	61
#define dxpRecordA05L	62
#define dxpRecordA05O	63
#define dxpRecordA06V	64
#define dxpRecordA06L	65
#define dxpRecordA06O	66
#define dxpRecordA07V	67
#define dxpRecordA07L	68
#define dxpRecordA07O	69
#define dxpRecordA08V	70
#define dxpRecordA08L	71
#define dxpRecordA08O	72
#define dxpRecordA09V	73
#define dxpRecordA09L	74
#define dxpRecordA09O	75
#define dxpRecordF01V	76
#define dxpRecordF01L	77
#define dxpRecordF01O	78
#define dxpRecordF02V	79
#define dxpRecordF02L	80
#define dxpRecordF02O	81
#define dxpRecordF03V	82
#define dxpRecordF03L	83
#define dxpRecordF03O	84
#define dxpRecordF04V	85
#define dxpRecordF04L	86
#define dxpRecordF04O	87
#define dxpRecordF05V	88
#define dxpRecordF05L	89
#define dxpRecordF05O	90
#define dxpRecordF06V	91
#define dxpRecordF06L	92
#define dxpRecordF06O	93
#define dxpRecordF07V	94
#define dxpRecordF07L	95
#define dxpRecordF07O	96
#define dxpRecordF08V	97
#define dxpRecordF08L	98
#define dxpRecordF08O	99
#define dxpRecordF09V	100
#define dxpRecordF09L	101
#define dxpRecordF09O	102
#define dxpRecordF10V	103
#define dxpRecordF10L	104
#define dxpRecordF10O	105
#define dxpRecordD01V	106
#define dxpRecordD01L	107
#define dxpRecordD01O	108
#define dxpRecordD02V	109
#define dxpRecordD02L	110
#define dxpRecordD02O	111
#define dxpRecordD03V	112
#define dxpRecordD03L	113
#define dxpRecordD03O	114
#define dxpRecordD04V	115
#define dxpRecordD04L	116
#define dxpRecordD04O	117
#define dxpRecordD05V	118
#define dxpRecordD05L	119
#define dxpRecordD05O	120
#define dxpRecordD06V	121
#define dxpRecordD06L	122
#define dxpRecordD06O	123
#define dxpRecordD07V	124
#define dxpRecordD07L	125
#define dxpRecordD07O	126
#define dxpRecordD08V	127
#define dxpRecordD08L	128
#define dxpRecordD08O	129
#define dxpRecordD09V	130
#define dxpRecordD09L	131
#define dxpRecordD09O	132
#define dxpRecordD10V	133
#define dxpRecordD10L	134
#define dxpRecordD10O	135
#define dxpRecordB01V	136
#define dxpRecordB01L	137
#define dxpRecordB01O	138
#define dxpRecordB02V	139
#define dxpRecordB02L	140
#define dxpRecordB02O	141
#define dxpRecordB03V	142
#define dxpRecordB03L	143
#define dxpRecordB03O	144
#define dxpRecordB04V	145
#define dxpRecordB04L	146
#define dxpRecordB04O	147
#define dxpRecordB05V	148
#define dxpRecordB05L	149
#define dxpRecordB05O	150
#define dxpRecordB06V	151
#define dxpRecordB06L	152
#define dxpRecordB06O	153
#define dxpRecordR01V	154
#define dxpRecordR01L	155
#define dxpRecordR01O	156
#define dxpRecordR02V	157
#define dxpRecordR02L	158
#define dxpRecordR02O	159
#define dxpRecordR03V	160
#define dxpRecordR03L	161
#define dxpRecordR03O	162
#define dxpRecordR04V	163
#define dxpRecordR04L	164
#define dxpRecordR04O	165
#define dxpRecordR05V	166
#define dxpRecordR05L	167
#define dxpRecordR05O	168
#define dxpRecordR06V	169
#define dxpRecordR06L	170
#define dxpRecordR06O	171
#define dxpRecordR07V	172
#define dxpRecordR07L	173
#define dxpRecordR07O	174
#define dxpRecordR08V	175
#define dxpRecordR08L	176
#define dxpRecordR08O	177
#define dxpRecordR09V	178
#define dxpRecordR09L	179
#define dxpRecordR09O	180
#define dxpRecordR10V	181
#define dxpRecordR10L	182
#define dxpRecordR10O	183
#define dxpRecordR11V	184
#define dxpRecordR11L	185
#define dxpRecordR11O	186
#define dxpRecordR12V	187
#define dxpRecordR12L	188
#define dxpRecordR12O	189
#define dxpRecordR13V	190
#define dxpRecordR13L	191
#define dxpRecordR13O	192
#define dxpRecordR14V	193
#define dxpRecordR14L	194
#define dxpRecordR14O	195
#define dxpRecordR15V	196
#define dxpRecordR15L	197
#define dxpRecordR15O	198
#define dxpRecordS01V	199
#define dxpRecordS01L	200
#define dxpRecordS01O	201
#define dxpRecordS02V	202
#define dxpRecordS02L	203
#define dxpRecordS02O	204
#define dxpRecordS03V	205
#define dxpRecordS03L	206
#define dxpRecordS03O	207
#define dxpRecordS04V	208
#define dxpRecordS04L	209
#define dxpRecordS04O	210
#define dxpRecordS05V	211
#define dxpRecordS05L	212
#define dxpRecordS05O	213
#define dxpRecordS06V	214
#define dxpRecordS06L	215
#define dxpRecordS06O	216
#define dxpRecordS07V	217
#define dxpRecordS07L	218
#define dxpRecordS07O	219
#define dxpRecordS08V	220
#define dxpRecordS08L	221
#define dxpRecordS08O	222
#define dxpRecordS09V	223
#define dxpRecordS09L	224
#define dxpRecordS09O	225
#define dxpRecordS10V	226
#define dxpRecordS10L	227
#define dxpRecordS10O	228
#define dxpRecordS11V	229
#define dxpRecordS11L	230
#define dxpRecordS11O	231
#define dxpRecordS12V	232
#define dxpRecordS12L	233
#define dxpRecordS12O	234
#define dxpRecordS13V	235
#define dxpRecordS13L	236
#define dxpRecordS13O	237
#define dxpRecordS14V	238
#define dxpRecordS14L	239
#define dxpRecordS14O	240
#define dxpRecordSTRT	241
#define dxpRecordSTOP	242
#define dxpRecordERAS	243
#define dxpRecordT01V	244
#define dxpRecordT01L	245
#define dxpRecordT02V	246
#define dxpRecordT02L	247
#define dxpRecordT03V	248
#define dxpRecordT03L	249
#define dxpRecordT04V	250
#define dxpRecordT04L	251
#define dxpRecordT05V	252
#define dxpRecordT05L	253
#define dxpRecordT06V	254
#define dxpRecordT06L	255
#define dxpRecordT07V	256
#define dxpRecordT07L	257
#define dxpRecordT08V	258
#define dxpRecordT08L	259
#define dxpRecordT09V	260
#define dxpRecordT09L	261
#define dxpRecordT10V	262
#define dxpRecordT10L	263
#define dxpRecordT11V	264
#define dxpRecordT11L	265
#define dxpRecordRCAL	266
#define dxpRecordCALR	267
#define dxpRecordPKTM	268
#define dxpRecordPKL	269
#define dxpRecordINP	270
#endif /*INCdxpH*/
#ifdef GEN_SIZE_OFFSET
int dxpRecordSizeOffset(dbRecordType *pdbRecordType)
{
    dxpRecord *prec = 0;
  pdbRecordType->papFldDes[0]->size=sizeof(prec->name);
  pdbRecordType->papFldDes[0]->offset=(short)((char *)&prec->name - (char *)prec);
  pdbRecordType->papFldDes[1]->size=sizeof(prec->desc);
  pdbRecordType->papFldDes[1]->offset=(short)((char *)&prec->desc - (char *)prec);
  pdbRecordType->papFldDes[2]->size=sizeof(prec->asg);
  pdbRecordType->papFldDes[2]->offset=(short)((char *)&prec->asg - (char *)prec);
  pdbRecordType->papFldDes[3]->size=sizeof(prec->scan);
  pdbRecordType->papFldDes[3]->offset=(short)((char *)&prec->scan - (char *)prec);
  pdbRecordType->papFldDes[4]->size=sizeof(prec->pini);
  pdbRecordType->papFldDes[4]->offset=(short)((char *)&prec->pini - (char *)prec);
  pdbRecordType->papFldDes[5]->size=sizeof(prec->phas);
  pdbRecordType->papFldDes[5]->offset=(short)((char *)&prec->phas - (char *)prec);
  pdbRecordType->papFldDes[6]->size=sizeof(prec->evnt);
  pdbRecordType->papFldDes[6]->offset=(short)((char *)&prec->evnt - (char *)prec);
  pdbRecordType->papFldDes[7]->size=sizeof(prec->tse);
  pdbRecordType->papFldDes[7]->offset=(short)((char *)&prec->tse - (char *)prec);
  pdbRecordType->papFldDes[8]->size=sizeof(prec->tsel);
  pdbRecordType->papFldDes[8]->offset=(short)((char *)&prec->tsel - (char *)prec);
  pdbRecordType->papFldDes[9]->size=sizeof(prec->dtyp);
  pdbRecordType->papFldDes[9]->offset=(short)((char *)&prec->dtyp - (char *)prec);
  pdbRecordType->papFldDes[10]->size=sizeof(prec->disv);
  pdbRecordType->papFldDes[10]->offset=(short)((char *)&prec->disv - (char *)prec);
  pdbRecordType->papFldDes[11]->size=sizeof(prec->disa);
  pdbRecordType->papFldDes[11]->offset=(short)((char *)&prec->disa - (char *)prec);
  pdbRecordType->papFldDes[12]->size=sizeof(prec->sdis);
  pdbRecordType->papFldDes[12]->offset=(short)((char *)&prec->sdis - (char *)prec);
  pdbRecordType->papFldDes[13]->size=sizeof(prec->mlok);
  pdbRecordType->papFldDes[13]->offset=(short)((char *)&prec->mlok - (char *)prec);
  pdbRecordType->papFldDes[14]->size=sizeof(prec->mlis);
  pdbRecordType->papFldDes[14]->offset=(short)((char *)&prec->mlis - (char *)prec);
  pdbRecordType->papFldDes[15]->size=sizeof(prec->disp);
  pdbRecordType->papFldDes[15]->offset=(short)((char *)&prec->disp - (char *)prec);
  pdbRecordType->papFldDes[16]->size=sizeof(prec->proc);
  pdbRecordType->papFldDes[16]->offset=(short)((char *)&prec->proc - (char *)prec);
  pdbRecordType->papFldDes[17]->size=sizeof(prec->stat);
  pdbRecordType->papFldDes[17]->offset=(short)((char *)&prec->stat - (char *)prec);
  pdbRecordType->papFldDes[18]->size=sizeof(prec->sevr);
  pdbRecordType->papFldDes[18]->offset=(short)((char *)&prec->sevr - (char *)prec);
  pdbRecordType->papFldDes[19]->size=sizeof(prec->nsta);
  pdbRecordType->papFldDes[19]->offset=(short)((char *)&prec->nsta - (char *)prec);
  pdbRecordType->papFldDes[20]->size=sizeof(prec->nsev);
  pdbRecordType->papFldDes[20]->offset=(short)((char *)&prec->nsev - (char *)prec);
  pdbRecordType->papFldDes[21]->size=sizeof(prec->acks);
  pdbRecordType->papFldDes[21]->offset=(short)((char *)&prec->acks - (char *)prec);
  pdbRecordType->papFldDes[22]->size=sizeof(prec->ackt);
  pdbRecordType->papFldDes[22]->offset=(short)((char *)&prec->ackt - (char *)prec);
  pdbRecordType->papFldDes[23]->size=sizeof(prec->diss);
  pdbRecordType->papFldDes[23]->offset=(short)((char *)&prec->diss - (char *)prec);
  pdbRecordType->papFldDes[24]->size=sizeof(prec->lcnt);
  pdbRecordType->papFldDes[24]->offset=(short)((char *)&prec->lcnt - (char *)prec);
  pdbRecordType->papFldDes[25]->size=sizeof(prec->pact);
  pdbRecordType->papFldDes[25]->offset=(short)((char *)&prec->pact - (char *)prec);
  pdbRecordType->papFldDes[26]->size=sizeof(prec->putf);
  pdbRecordType->papFldDes[26]->offset=(short)((char *)&prec->putf - (char *)prec);
  pdbRecordType->papFldDes[27]->size=sizeof(prec->rpro);
  pdbRecordType->papFldDes[27]->offset=(short)((char *)&prec->rpro - (char *)prec);
  pdbRecordType->papFldDes[28]->size=sizeof(prec->asp);
  pdbRecordType->papFldDes[28]->offset=(short)((char *)&prec->asp - (char *)prec);
  pdbRecordType->papFldDes[29]->size=sizeof(prec->ppn);
  pdbRecordType->papFldDes[29]->offset=(short)((char *)&prec->ppn - (char *)prec);
  pdbRecordType->papFldDes[30]->size=sizeof(prec->ppnn);
  pdbRecordType->papFldDes[30]->offset=(short)((char *)&prec->ppnn - (char *)prec);
  pdbRecordType->papFldDes[31]->size=sizeof(prec->spvt);
  pdbRecordType->papFldDes[31]->offset=(short)((char *)&prec->spvt - (char *)prec);
  pdbRecordType->papFldDes[32]->size=sizeof(prec->rset);
  pdbRecordType->papFldDes[32]->offset=(short)((char *)&prec->rset - (char *)prec);
  pdbRecordType->papFldDes[33]->size=sizeof(prec->dset);
  pdbRecordType->papFldDes[33]->offset=(short)((char *)&prec->dset - (char *)prec);
  pdbRecordType->papFldDes[34]->size=sizeof(prec->dpvt);
  pdbRecordType->papFldDes[34]->offset=(short)((char *)&prec->dpvt - (char *)prec);
  pdbRecordType->papFldDes[35]->size=sizeof(prec->rdes);
  pdbRecordType->papFldDes[35]->offset=(short)((char *)&prec->rdes - (char *)prec);
  pdbRecordType->papFldDes[36]->size=sizeof(prec->lset);
  pdbRecordType->papFldDes[36]->offset=(short)((char *)&prec->lset - (char *)prec);
  pdbRecordType->papFldDes[37]->size=sizeof(prec->prio);
  pdbRecordType->papFldDes[37]->offset=(short)((char *)&prec->prio - (char *)prec);
  pdbRecordType->papFldDes[38]->size=sizeof(prec->tpro);
  pdbRecordType->papFldDes[38]->offset=(short)((char *)&prec->tpro - (char *)prec);
  pdbRecordType->papFldDes[39]->size=sizeof(prec->bkpt);
  pdbRecordType->papFldDes[39]->offset=(short)((char *)&prec->bkpt - (char *)prec);
  pdbRecordType->papFldDes[40]->size=sizeof(prec->udf);
  pdbRecordType->papFldDes[40]->offset=(short)((char *)&prec->udf - (char *)prec);
  pdbRecordType->papFldDes[41]->size=sizeof(prec->time);
  pdbRecordType->papFldDes[41]->offset=(short)((char *)&prec->time - (char *)prec);
  pdbRecordType->papFldDes[42]->size=sizeof(prec->flnk);
  pdbRecordType->papFldDes[42]->offset=(short)((char *)&prec->flnk - (char *)prec);
  pdbRecordType->papFldDes[43]->size=sizeof(prec->val);
  pdbRecordType->papFldDes[43]->offset=(short)((char *)&prec->val - (char *)prec);
  pdbRecordType->papFldDes[44]->size=sizeof(prec->bptr);
  pdbRecordType->papFldDes[44]->offset=(short)((char *)&prec->bptr - (char *)prec);
  pdbRecordType->papFldDes[45]->size=sizeof(prec->base);
  pdbRecordType->papFldDes[45]->offset=(short)((char *)&prec->base - (char *)prec);
  pdbRecordType->papFldDes[46]->size=sizeof(prec->pptr);
  pdbRecordType->papFldDes[46]->offset=(short)((char *)&prec->pptr - (char *)prec);
  pdbRecordType->papFldDes[47]->size=sizeof(prec->parm);
  pdbRecordType->papFldDes[47]->offset=(short)((char *)&prec->parm - (char *)prec);
  pdbRecordType->papFldDes[48]->size=sizeof(prec->mtyp);
  pdbRecordType->papFldDes[48]->offset=(short)((char *)&prec->mtyp - (char *)prec);
  pdbRecordType->papFldDes[49]->size=sizeof(prec->a01v);
  pdbRecordType->papFldDes[49]->offset=(short)((char *)&prec->a01v - (char *)prec);
  pdbRecordType->papFldDes[50]->size=sizeof(prec->a01l);
  pdbRecordType->papFldDes[50]->offset=(short)((char *)&prec->a01l - (char *)prec);
  pdbRecordType->papFldDes[51]->size=sizeof(prec->a01o);
  pdbRecordType->papFldDes[51]->offset=(short)((char *)&prec->a01o - (char *)prec);
  pdbRecordType->papFldDes[52]->size=sizeof(prec->a02v);
  pdbRecordType->papFldDes[52]->offset=(short)((char *)&prec->a02v - (char *)prec);
  pdbRecordType->papFldDes[53]->size=sizeof(prec->a02l);
  pdbRecordType->papFldDes[53]->offset=(short)((char *)&prec->a02l - (char *)prec);
  pdbRecordType->papFldDes[54]->size=sizeof(prec->a02o);
  pdbRecordType->papFldDes[54]->offset=(short)((char *)&prec->a02o - (char *)prec);
  pdbRecordType->papFldDes[55]->size=sizeof(prec->a03v);
  pdbRecordType->papFldDes[55]->offset=(short)((char *)&prec->a03v - (char *)prec);
  pdbRecordType->papFldDes[56]->size=sizeof(prec->a03l);
  pdbRecordType->papFldDes[56]->offset=(short)((char *)&prec->a03l - (char *)prec);
  pdbRecordType->papFldDes[57]->size=sizeof(prec->a03o);
  pdbRecordType->papFldDes[57]->offset=(short)((char *)&prec->a03o - (char *)prec);
  pdbRecordType->papFldDes[58]->size=sizeof(prec->a04v);
  pdbRecordType->papFldDes[58]->offset=(short)((char *)&prec->a04v - (char *)prec);
  pdbRecordType->papFldDes[59]->size=sizeof(prec->a04l);
  pdbRecordType->papFldDes[59]->offset=(short)((char *)&prec->a04l - (char *)prec);
  pdbRecordType->papFldDes[60]->size=sizeof(prec->a04o);
  pdbRecordType->papFldDes[60]->offset=(short)((char *)&prec->a04o - (char *)prec);
  pdbRecordType->papFldDes[61]->size=sizeof(prec->a05v);
  pdbRecordType->papFldDes[61]->offset=(short)((char *)&prec->a05v - (char *)prec);
  pdbRecordType->papFldDes[62]->size=sizeof(prec->a05l);
  pdbRecordType->papFldDes[62]->offset=(short)((char *)&prec->a05l - (char *)prec);
  pdbRecordType->papFldDes[63]->size=sizeof(prec->a05o);
  pdbRecordType->papFldDes[63]->offset=(short)((char *)&prec->a05o - (char *)prec);
  pdbRecordType->papFldDes[64]->size=sizeof(prec->a06v);
  pdbRecordType->papFldDes[64]->offset=(short)((char *)&prec->a06v - (char *)prec);
  pdbRecordType->papFldDes[65]->size=sizeof(prec->a06l);
  pdbRecordType->papFldDes[65]->offset=(short)((char *)&prec->a06l - (char *)prec);
  pdbRecordType->papFldDes[66]->size=sizeof(prec->a06o);
  pdbRecordType->papFldDes[66]->offset=(short)((char *)&prec->a06o - (char *)prec);
  pdbRecordType->papFldDes[67]->size=sizeof(prec->a07v);
  pdbRecordType->papFldDes[67]->offset=(short)((char *)&prec->a07v - (char *)prec);
  pdbRecordType->papFldDes[68]->size=sizeof(prec->a07l);
  pdbRecordType->papFldDes[68]->offset=(short)((char *)&prec->a07l - (char *)prec);
  pdbRecordType->papFldDes[69]->size=sizeof(prec->a07o);
  pdbRecordType->papFldDes[69]->offset=(short)((char *)&prec->a07o - (char *)prec);
  pdbRecordType->papFldDes[70]->size=sizeof(prec->a08v);
  pdbRecordType->papFldDes[70]->offset=(short)((char *)&prec->a08v - (char *)prec);
  pdbRecordType->papFldDes[71]->size=sizeof(prec->a08l);
  pdbRecordType->papFldDes[71]->offset=(short)((char *)&prec->a08l - (char *)prec);
  pdbRecordType->papFldDes[72]->size=sizeof(prec->a08o);
  pdbRecordType->papFldDes[72]->offset=(short)((char *)&prec->a08o - (char *)prec);
  pdbRecordType->papFldDes[73]->size=sizeof(prec->a09v);
  pdbRecordType->papFldDes[73]->offset=(short)((char *)&prec->a09v - (char *)prec);
  pdbRecordType->papFldDes[74]->size=sizeof(prec->a09l);
  pdbRecordType->papFldDes[74]->offset=(short)((char *)&prec->a09l - (char *)prec);
  pdbRecordType->papFldDes[75]->size=sizeof(prec->a09o);
  pdbRecordType->papFldDes[75]->offset=(short)((char *)&prec->a09o - (char *)prec);
  pdbRecordType->papFldDes[76]->size=sizeof(prec->f01v);
  pdbRecordType->papFldDes[76]->offset=(short)((char *)&prec->f01v - (char *)prec);
  pdbRecordType->papFldDes[77]->size=sizeof(prec->f01l);
  pdbRecordType->papFldDes[77]->offset=(short)((char *)&prec->f01l - (char *)prec);
  pdbRecordType->papFldDes[78]->size=sizeof(prec->f01o);
  pdbRecordType->papFldDes[78]->offset=(short)((char *)&prec->f01o - (char *)prec);
  pdbRecordType->papFldDes[79]->size=sizeof(prec->f02v);
  pdbRecordType->papFldDes[79]->offset=(short)((char *)&prec->f02v - (char *)prec);
  pdbRecordType->papFldDes[80]->size=sizeof(prec->f02l);
  pdbRecordType->papFldDes[80]->offset=(short)((char *)&prec->f02l - (char *)prec);
  pdbRecordType->papFldDes[81]->size=sizeof(prec->f02o);
  pdbRecordType->papFldDes[81]->offset=(short)((char *)&prec->f02o - (char *)prec);
  pdbRecordType->papFldDes[82]->size=sizeof(prec->f03v);
  pdbRecordType->papFldDes[82]->offset=(short)((char *)&prec->f03v - (char *)prec);
  pdbRecordType->papFldDes[83]->size=sizeof(prec->f03l);
  pdbRecordType->papFldDes[83]->offset=(short)((char *)&prec->f03l - (char *)prec);
  pdbRecordType->papFldDes[84]->size=sizeof(prec->f03o);
  pdbRecordType->papFldDes[84]->offset=(short)((char *)&prec->f03o - (char *)prec);
  pdbRecordType->papFldDes[85]->size=sizeof(prec->f04v);
  pdbRecordType->papFldDes[85]->offset=(short)((char *)&prec->f04v - (char *)prec);
  pdbRecordType->papFldDes[86]->size=sizeof(prec->f04l);
  pdbRecordType->papFldDes[86]->offset=(short)((char *)&prec->f04l - (char *)prec);
  pdbRecordType->papFldDes[87]->size=sizeof(prec->f04o);
  pdbRecordType->papFldDes[87]->offset=(short)((char *)&prec->f04o - (char *)prec);
  pdbRecordType->papFldDes[88]->size=sizeof(prec->f05v);
  pdbRecordType->papFldDes[88]->offset=(short)((char *)&prec->f05v - (char *)prec);
  pdbRecordType->papFldDes[89]->size=sizeof(prec->f05l);
  pdbRecordType->papFldDes[89]->offset=(short)((char *)&prec->f05l - (char *)prec);
  pdbRecordType->papFldDes[90]->size=sizeof(prec->f05o);
  pdbRecordType->papFldDes[90]->offset=(short)((char *)&prec->f05o - (char *)prec);
  pdbRecordType->papFldDes[91]->size=sizeof(prec->f06v);
  pdbRecordType->papFldDes[91]->offset=(short)((char *)&prec->f06v - (char *)prec);
  pdbRecordType->papFldDes[92]->size=sizeof(prec->f06l);
  pdbRecordType->papFldDes[92]->offset=(short)((char *)&prec->f06l - (char *)prec);
  pdbRecordType->papFldDes[93]->size=sizeof(prec->f06o);
  pdbRecordType->papFldDes[93]->offset=(short)((char *)&prec->f06o - (char *)prec);
  pdbRecordType->papFldDes[94]->size=sizeof(prec->f07v);
  pdbRecordType->papFldDes[94]->offset=(short)((char *)&prec->f07v - (char *)prec);
  pdbRecordType->papFldDes[95]->size=sizeof(prec->f07l);
  pdbRecordType->papFldDes[95]->offset=(short)((char *)&prec->f07l - (char *)prec);
  pdbRecordType->papFldDes[96]->size=sizeof(prec->f07o);
  pdbRecordType->papFldDes[96]->offset=(short)((char *)&prec->f07o - (char *)prec);
  pdbRecordType->papFldDes[97]->size=sizeof(prec->f08v);
  pdbRecordType->papFldDes[97]->offset=(short)((char *)&prec->f08v - (char *)prec);
  pdbRecordType->papFldDes[98]->size=sizeof(prec->f08l);
  pdbRecordType->papFldDes[98]->offset=(short)((char *)&prec->f08l - (char *)prec);
  pdbRecordType->papFldDes[99]->size=sizeof(prec->f08o);
  pdbRecordType->papFldDes[99]->offset=(short)((char *)&prec->f08o - (char *)prec);
  pdbRecordType->papFldDes[100]->size=sizeof(prec->f09v);
  pdbRecordType->papFldDes[100]->offset=(short)((char *)&prec->f09v - (char *)prec);
  pdbRecordType->papFldDes[101]->size=sizeof(prec->f09l);
  pdbRecordType->papFldDes[101]->offset=(short)((char *)&prec->f09l - (char *)prec);
  pdbRecordType->papFldDes[102]->size=sizeof(prec->f09o);
  pdbRecordType->papFldDes[102]->offset=(short)((char *)&prec->f09o - (char *)prec);
  pdbRecordType->papFldDes[103]->size=sizeof(prec->f10v);
  pdbRecordType->papFldDes[103]->offset=(short)((char *)&prec->f10v - (char *)prec);
  pdbRecordType->papFldDes[104]->size=sizeof(prec->f10l);
  pdbRecordType->papFldDes[104]->offset=(short)((char *)&prec->f10l - (char *)prec);
  pdbRecordType->papFldDes[105]->size=sizeof(prec->f10o);
  pdbRecordType->papFldDes[105]->offset=(short)((char *)&prec->f10o - (char *)prec);
  pdbRecordType->papFldDes[106]->size=sizeof(prec->d01v);
  pdbRecordType->papFldDes[106]->offset=(short)((char *)&prec->d01v - (char *)prec);
  pdbRecordType->papFldDes[107]->size=sizeof(prec->d01l);
  pdbRecordType->papFldDes[107]->offset=(short)((char *)&prec->d01l - (char *)prec);
  pdbRecordType->papFldDes[108]->size=sizeof(prec->d01o);
  pdbRecordType->papFldDes[108]->offset=(short)((char *)&prec->d01o - (char *)prec);
  pdbRecordType->papFldDes[109]->size=sizeof(prec->d02v);
  pdbRecordType->papFldDes[109]->offset=(short)((char *)&prec->d02v - (char *)prec);
  pdbRecordType->papFldDes[110]->size=sizeof(prec->d02l);
  pdbRecordType->papFldDes[110]->offset=(short)((char *)&prec->d02l - (char *)prec);
  pdbRecordType->papFldDes[111]->size=sizeof(prec->d02o);
  pdbRecordType->papFldDes[111]->offset=(short)((char *)&prec->d02o - (char *)prec);
  pdbRecordType->papFldDes[112]->size=sizeof(prec->d03v);
  pdbRecordType->papFldDes[112]->offset=(short)((char *)&prec->d03v - (char *)prec);
  pdbRecordType->papFldDes[113]->size=sizeof(prec->d03l);
  pdbRecordType->papFldDes[113]->offset=(short)((char *)&prec->d03l - (char *)prec);
  pdbRecordType->papFldDes[114]->size=sizeof(prec->d03o);
  pdbRecordType->papFldDes[114]->offset=(short)((char *)&prec->d03o - (char *)prec);
  pdbRecordType->papFldDes[115]->size=sizeof(prec->d04v);
  pdbRecordType->papFldDes[115]->offset=(short)((char *)&prec->d04v - (char *)prec);
  pdbRecordType->papFldDes[116]->size=sizeof(prec->d04l);
  pdbRecordType->papFldDes[116]->offset=(short)((char *)&prec->d04l - (char *)prec);
  pdbRecordType->papFldDes[117]->size=sizeof(prec->d04o);
  pdbRecordType->papFldDes[117]->offset=(short)((char *)&prec->d04o - (char *)prec);
  pdbRecordType->papFldDes[118]->size=sizeof(prec->d05v);
  pdbRecordType->papFldDes[118]->offset=(short)((char *)&prec->d05v - (char *)prec);
  pdbRecordType->papFldDes[119]->size=sizeof(prec->d05l);
  pdbRecordType->papFldDes[119]->offset=(short)((char *)&prec->d05l - (char *)prec);
  pdbRecordType->papFldDes[120]->size=sizeof(prec->d05o);
  pdbRecordType->papFldDes[120]->offset=(short)((char *)&prec->d05o - (char *)prec);
  pdbRecordType->papFldDes[121]->size=sizeof(prec->d06v);
  pdbRecordType->papFldDes[121]->offset=(short)((char *)&prec->d06v - (char *)prec);
  pdbRecordType->papFldDes[122]->size=sizeof(prec->d06l);
  pdbRecordType->papFldDes[122]->offset=(short)((char *)&prec->d06l - (char *)prec);
  pdbRecordType->papFldDes[123]->size=sizeof(prec->d06o);
  pdbRecordType->papFldDes[123]->offset=(short)((char *)&prec->d06o - (char *)prec);
  pdbRecordType->papFldDes[124]->size=sizeof(prec->d07v);
  pdbRecordType->papFldDes[124]->offset=(short)((char *)&prec->d07v - (char *)prec);
  pdbRecordType->papFldDes[125]->size=sizeof(prec->d07l);
  pdbRecordType->papFldDes[125]->offset=(short)((char *)&prec->d07l - (char *)prec);
  pdbRecordType->papFldDes[126]->size=sizeof(prec->d07o);
  pdbRecordType->papFldDes[126]->offset=(short)((char *)&prec->d07o - (char *)prec);
  pdbRecordType->papFldDes[127]->size=sizeof(prec->d08v);
  pdbRecordType->papFldDes[127]->offset=(short)((char *)&prec->d08v - (char *)prec);
  pdbRecordType->papFldDes[128]->size=sizeof(prec->d08l);
  pdbRecordType->papFldDes[128]->offset=(short)((char *)&prec->d08l - (char *)prec);
  pdbRecordType->papFldDes[129]->size=sizeof(prec->d08o);
  pdbRecordType->papFldDes[129]->offset=(short)((char *)&prec->d08o - (char *)prec);
  pdbRecordType->papFldDes[130]->size=sizeof(prec->d09v);
  pdbRecordType->papFldDes[130]->offset=(short)((char *)&prec->d09v - (char *)prec);
  pdbRecordType->papFldDes[131]->size=sizeof(prec->d09l);
  pdbRecordType->papFldDes[131]->offset=(short)((char *)&prec->d09l - (char *)prec);
  pdbRecordType->papFldDes[132]->size=sizeof(prec->d09o);
  pdbRecordType->papFldDes[132]->offset=(short)((char *)&prec->d09o - (char *)prec);
  pdbRecordType->papFldDes[133]->size=sizeof(prec->d10v);
  pdbRecordType->papFldDes[133]->offset=(short)((char *)&prec->d10v - (char *)prec);
  pdbRecordType->papFldDes[134]->size=sizeof(prec->d10l);
  pdbRecordType->papFldDes[134]->offset=(short)((char *)&prec->d10l - (char *)prec);
  pdbRecordType->papFldDes[135]->size=sizeof(prec->d10o);
  pdbRecordType->papFldDes[135]->offset=(short)((char *)&prec->d10o - (char *)prec);
  pdbRecordType->papFldDes[136]->size=sizeof(prec->b01v);
  pdbRecordType->papFldDes[136]->offset=(short)((char *)&prec->b01v - (char *)prec);
  pdbRecordType->papFldDes[137]->size=sizeof(prec->b01l);
  pdbRecordType->papFldDes[137]->offset=(short)((char *)&prec->b01l - (char *)prec);
  pdbRecordType->papFldDes[138]->size=sizeof(prec->b01o);
  pdbRecordType->papFldDes[138]->offset=(short)((char *)&prec->b01o - (char *)prec);
  pdbRecordType->papFldDes[139]->size=sizeof(prec->b02v);
  pdbRecordType->papFldDes[139]->offset=(short)((char *)&prec->b02v - (char *)prec);
  pdbRecordType->papFldDes[140]->size=sizeof(prec->b02l);
  pdbRecordType->papFldDes[140]->offset=(short)((char *)&prec->b02l - (char *)prec);
  pdbRecordType->papFldDes[141]->size=sizeof(prec->b02o);
  pdbRecordType->papFldDes[141]->offset=(short)((char *)&prec->b02o - (char *)prec);
  pdbRecordType->papFldDes[142]->size=sizeof(prec->b03v);
  pdbRecordType->papFldDes[142]->offset=(short)((char *)&prec->b03v - (char *)prec);
  pdbRecordType->papFldDes[143]->size=sizeof(prec->b03l);
  pdbRecordType->papFldDes[143]->offset=(short)((char *)&prec->b03l - (char *)prec);
  pdbRecordType->papFldDes[144]->size=sizeof(prec->b03o);
  pdbRecordType->papFldDes[144]->offset=(short)((char *)&prec->b03o - (char *)prec);
  pdbRecordType->papFldDes[145]->size=sizeof(prec->b04v);
  pdbRecordType->papFldDes[145]->offset=(short)((char *)&prec->b04v - (char *)prec);
  pdbRecordType->papFldDes[146]->size=sizeof(prec->b04l);
  pdbRecordType->papFldDes[146]->offset=(short)((char *)&prec->b04l - (char *)prec);
  pdbRecordType->papFldDes[147]->size=sizeof(prec->b04o);
  pdbRecordType->papFldDes[147]->offset=(short)((char *)&prec->b04o - (char *)prec);
  pdbRecordType->papFldDes[148]->size=sizeof(prec->b05v);
  pdbRecordType->papFldDes[148]->offset=(short)((char *)&prec->b05v - (char *)prec);
  pdbRecordType->papFldDes[149]->size=sizeof(prec->b05l);
  pdbRecordType->papFldDes[149]->offset=(short)((char *)&prec->b05l - (char *)prec);
  pdbRecordType->papFldDes[150]->size=sizeof(prec->b05o);
  pdbRecordType->papFldDes[150]->offset=(short)((char *)&prec->b05o - (char *)prec);
  pdbRecordType->papFldDes[151]->size=sizeof(prec->b06v);
  pdbRecordType->papFldDes[151]->offset=(short)((char *)&prec->b06v - (char *)prec);
  pdbRecordType->papFldDes[152]->size=sizeof(prec->b06l);
  pdbRecordType->papFldDes[152]->offset=(short)((char *)&prec->b06l - (char *)prec);
  pdbRecordType->papFldDes[153]->size=sizeof(prec->b06o);
  pdbRecordType->papFldDes[153]->offset=(short)((char *)&prec->b06o - (char *)prec);
  pdbRecordType->papFldDes[154]->size=sizeof(prec->r01v);
  pdbRecordType->papFldDes[154]->offset=(short)((char *)&prec->r01v - (char *)prec);
  pdbRecordType->papFldDes[155]->size=sizeof(prec->r01l);
  pdbRecordType->papFldDes[155]->offset=(short)((char *)&prec->r01l - (char *)prec);
  pdbRecordType->papFldDes[156]->size=sizeof(prec->r01o);
  pdbRecordType->papFldDes[156]->offset=(short)((char *)&prec->r01o - (char *)prec);
  pdbRecordType->papFldDes[157]->size=sizeof(prec->r02v);
  pdbRecordType->papFldDes[157]->offset=(short)((char *)&prec->r02v - (char *)prec);
  pdbRecordType->papFldDes[158]->size=sizeof(prec->r02l);
  pdbRecordType->papFldDes[158]->offset=(short)((char *)&prec->r02l - (char *)prec);
  pdbRecordType->papFldDes[159]->size=sizeof(prec->r02o);
  pdbRecordType->papFldDes[159]->offset=(short)((char *)&prec->r02o - (char *)prec);
  pdbRecordType->papFldDes[160]->size=sizeof(prec->r03v);
  pdbRecordType->papFldDes[160]->offset=(short)((char *)&prec->r03v - (char *)prec);
  pdbRecordType->papFldDes[161]->size=sizeof(prec->r03l);
  pdbRecordType->papFldDes[161]->offset=(short)((char *)&prec->r03l - (char *)prec);
  pdbRecordType->papFldDes[162]->size=sizeof(prec->r03o);
  pdbRecordType->papFldDes[162]->offset=(short)((char *)&prec->r03o - (char *)prec);
  pdbRecordType->papFldDes[163]->size=sizeof(prec->r04v);
  pdbRecordType->papFldDes[163]->offset=(short)((char *)&prec->r04v - (char *)prec);
  pdbRecordType->papFldDes[164]->size=sizeof(prec->r04l);
  pdbRecordType->papFldDes[164]->offset=(short)((char *)&prec->r04l - (char *)prec);
  pdbRecordType->papFldDes[165]->size=sizeof(prec->r04o);
  pdbRecordType->papFldDes[165]->offset=(short)((char *)&prec->r04o - (char *)prec);
  pdbRecordType->papFldDes[166]->size=sizeof(prec->r05v);
  pdbRecordType->papFldDes[166]->offset=(short)((char *)&prec->r05v - (char *)prec);
  pdbRecordType->papFldDes[167]->size=sizeof(prec->r05l);
  pdbRecordType->papFldDes[167]->offset=(short)((char *)&prec->r05l - (char *)prec);
  pdbRecordType->papFldDes[168]->size=sizeof(prec->r05o);
  pdbRecordType->papFldDes[168]->offset=(short)((char *)&prec->r05o - (char *)prec);
  pdbRecordType->papFldDes[169]->size=sizeof(prec->r06v);
  pdbRecordType->papFldDes[169]->offset=(short)((char *)&prec->r06v - (char *)prec);
  pdbRecordType->papFldDes[170]->size=sizeof(prec->r06l);
  pdbRecordType->papFldDes[170]->offset=(short)((char *)&prec->r06l - (char *)prec);
  pdbRecordType->papFldDes[171]->size=sizeof(prec->r06o);
  pdbRecordType->papFldDes[171]->offset=(short)((char *)&prec->r06o - (char *)prec);
  pdbRecordType->papFldDes[172]->size=sizeof(prec->r07v);
  pdbRecordType->papFldDes[172]->offset=(short)((char *)&prec->r07v - (char *)prec);
  pdbRecordType->papFldDes[173]->size=sizeof(prec->r07l);
  pdbRecordType->papFldDes[173]->offset=(short)((char *)&prec->r07l - (char *)prec);
  pdbRecordType->papFldDes[174]->size=sizeof(prec->r07o);
  pdbRecordType->papFldDes[174]->offset=(short)((char *)&prec->r07o - (char *)prec);
  pdbRecordType->papFldDes[175]->size=sizeof(prec->r08v);
  pdbRecordType->papFldDes[175]->offset=(short)((char *)&prec->r08v - (char *)prec);
  pdbRecordType->papFldDes[176]->size=sizeof(prec->r08l);
  pdbRecordType->papFldDes[176]->offset=(short)((char *)&prec->r08l - (char *)prec);
  pdbRecordType->papFldDes[177]->size=sizeof(prec->r08o);
  pdbRecordType->papFldDes[177]->offset=(short)((char *)&prec->r08o - (char *)prec);
  pdbRecordType->papFldDes[178]->size=sizeof(prec->r09v);
  pdbRecordType->papFldDes[178]->offset=(short)((char *)&prec->r09v - (char *)prec);
  pdbRecordType->papFldDes[179]->size=sizeof(prec->r09l);
  pdbRecordType->papFldDes[179]->offset=(short)((char *)&prec->r09l - (char *)prec);
  pdbRecordType->papFldDes[180]->size=sizeof(prec->r09o);
  pdbRecordType->papFldDes[180]->offset=(short)((char *)&prec->r09o - (char *)prec);
  pdbRecordType->papFldDes[181]->size=sizeof(prec->r10v);
  pdbRecordType->papFldDes[181]->offset=(short)((char *)&prec->r10v - (char *)prec);
  pdbRecordType->papFldDes[182]->size=sizeof(prec->r10l);
  pdbRecordType->papFldDes[182]->offset=(short)((char *)&prec->r10l - (char *)prec);
  pdbRecordType->papFldDes[183]->size=sizeof(prec->r10o);
  pdbRecordType->papFldDes[183]->offset=(short)((char *)&prec->r10o - (char *)prec);
  pdbRecordType->papFldDes[184]->size=sizeof(prec->r11v);
  pdbRecordType->papFldDes[184]->offset=(short)((char *)&prec->r11v - (char *)prec);
  pdbRecordType->papFldDes[185]->size=sizeof(prec->r11l);
  pdbRecordType->papFldDes[185]->offset=(short)((char *)&prec->r11l - (char *)prec);
  pdbRecordType->papFldDes[186]->size=sizeof(prec->r11o);
  pdbRecordType->papFldDes[186]->offset=(short)((char *)&prec->r11o - (char *)prec);
  pdbRecordType->papFldDes[187]->size=sizeof(prec->r12v);
  pdbRecordType->papFldDes[187]->offset=(short)((char *)&prec->r12v - (char *)prec);
  pdbRecordType->papFldDes[188]->size=sizeof(prec->r12l);
  pdbRecordType->papFldDes[188]->offset=(short)((char *)&prec->r12l - (char *)prec);
  pdbRecordType->papFldDes[189]->size=sizeof(prec->r12o);
  pdbRecordType->papFldDes[189]->offset=(short)((char *)&prec->r12o - (char *)prec);
  pdbRecordType->papFldDes[190]->size=sizeof(prec->r13v);
  pdbRecordType->papFldDes[190]->offset=(short)((char *)&prec->r13v - (char *)prec);
  pdbRecordType->papFldDes[191]->size=sizeof(prec->r13l);
  pdbRecordType->papFldDes[191]->offset=(short)((char *)&prec->r13l - (char *)prec);
  pdbRecordType->papFldDes[192]->size=sizeof(prec->r13o);
  pdbRecordType->papFldDes[192]->offset=(short)((char *)&prec->r13o - (char *)prec);
  pdbRecordType->papFldDes[193]->size=sizeof(prec->r14v);
  pdbRecordType->papFldDes[193]->offset=(short)((char *)&prec->r14v - (char *)prec);
  pdbRecordType->papFldDes[194]->size=sizeof(prec->r14l);
  pdbRecordType->papFldDes[194]->offset=(short)((char *)&prec->r14l - (char *)prec);
  pdbRecordType->papFldDes[195]->size=sizeof(prec->r14o);
  pdbRecordType->papFldDes[195]->offset=(short)((char *)&prec->r14o - (char *)prec);
  pdbRecordType->papFldDes[196]->size=sizeof(prec->r15v);
  pdbRecordType->papFldDes[196]->offset=(short)((char *)&prec->r15v - (char *)prec);
  pdbRecordType->papFldDes[197]->size=sizeof(prec->r15l);
  pdbRecordType->papFldDes[197]->offset=(short)((char *)&prec->r15l - (char *)prec);
  pdbRecordType->papFldDes[198]->size=sizeof(prec->r15o);
  pdbRecordType->papFldDes[198]->offset=(short)((char *)&prec->r15o - (char *)prec);
  pdbRecordType->papFldDes[199]->size=sizeof(prec->s01v);
  pdbRecordType->papFldDes[199]->offset=(short)((char *)&prec->s01v - (char *)prec);
  pdbRecordType->papFldDes[200]->size=sizeof(prec->s01l);
  pdbRecordType->papFldDes[200]->offset=(short)((char *)&prec->s01l - (char *)prec);
  pdbRecordType->papFldDes[201]->size=sizeof(prec->s01o);
  pdbRecordType->papFldDes[201]->offset=(short)((char *)&prec->s01o - (char *)prec);
  pdbRecordType->papFldDes[202]->size=sizeof(prec->s02v);
  pdbRecordType->papFldDes[202]->offset=(short)((char *)&prec->s02v - (char *)prec);
  pdbRecordType->papFldDes[203]->size=sizeof(prec->s02l);
  pdbRecordType->papFldDes[203]->offset=(short)((char *)&prec->s02l - (char *)prec);
  pdbRecordType->papFldDes[204]->size=sizeof(prec->s02o);
  pdbRecordType->papFldDes[204]->offset=(short)((char *)&prec->s02o - (char *)prec);
  pdbRecordType->papFldDes[205]->size=sizeof(prec->s03v);
  pdbRecordType->papFldDes[205]->offset=(short)((char *)&prec->s03v - (char *)prec);
  pdbRecordType->papFldDes[206]->size=sizeof(prec->s03l);
  pdbRecordType->papFldDes[206]->offset=(short)((char *)&prec->s03l - (char *)prec);
  pdbRecordType->papFldDes[207]->size=sizeof(prec->s03o);
  pdbRecordType->papFldDes[207]->offset=(short)((char *)&prec->s03o - (char *)prec);
  pdbRecordType->papFldDes[208]->size=sizeof(prec->s04v);
  pdbRecordType->papFldDes[208]->offset=(short)((char *)&prec->s04v - (char *)prec);
  pdbRecordType->papFldDes[209]->size=sizeof(prec->s04l);
  pdbRecordType->papFldDes[209]->offset=(short)((char *)&prec->s04l - (char *)prec);
  pdbRecordType->papFldDes[210]->size=sizeof(prec->s04o);
  pdbRecordType->papFldDes[210]->offset=(short)((char *)&prec->s04o - (char *)prec);
  pdbRecordType->papFldDes[211]->size=sizeof(prec->s05v);
  pdbRecordType->papFldDes[211]->offset=(short)((char *)&prec->s05v - (char *)prec);
  pdbRecordType->papFldDes[212]->size=sizeof(prec->s05l);
  pdbRecordType->papFldDes[212]->offset=(short)((char *)&prec->s05l - (char *)prec);
  pdbRecordType->papFldDes[213]->size=sizeof(prec->s05o);
  pdbRecordType->papFldDes[213]->offset=(short)((char *)&prec->s05o - (char *)prec);
  pdbRecordType->papFldDes[214]->size=sizeof(prec->s06v);
  pdbRecordType->papFldDes[214]->offset=(short)((char *)&prec->s06v - (char *)prec);
  pdbRecordType->papFldDes[215]->size=sizeof(prec->s06l);
  pdbRecordType->papFldDes[215]->offset=(short)((char *)&prec->s06l - (char *)prec);
  pdbRecordType->papFldDes[216]->size=sizeof(prec->s06o);
  pdbRecordType->papFldDes[216]->offset=(short)((char *)&prec->s06o - (char *)prec);
  pdbRecordType->papFldDes[217]->size=sizeof(prec->s07v);
  pdbRecordType->papFldDes[217]->offset=(short)((char *)&prec->s07v - (char *)prec);
  pdbRecordType->papFldDes[218]->size=sizeof(prec->s07l);
  pdbRecordType->papFldDes[218]->offset=(short)((char *)&prec->s07l - (char *)prec);
  pdbRecordType->papFldDes[219]->size=sizeof(prec->s07o);
  pdbRecordType->papFldDes[219]->offset=(short)((char *)&prec->s07o - (char *)prec);
  pdbRecordType->papFldDes[220]->size=sizeof(prec->s08v);
  pdbRecordType->papFldDes[220]->offset=(short)((char *)&prec->s08v - (char *)prec);
  pdbRecordType->papFldDes[221]->size=sizeof(prec->s08l);
  pdbRecordType->papFldDes[221]->offset=(short)((char *)&prec->s08l - (char *)prec);
  pdbRecordType->papFldDes[222]->size=sizeof(prec->s08o);
  pdbRecordType->papFldDes[222]->offset=(short)((char *)&prec->s08o - (char *)prec);
  pdbRecordType->papFldDes[223]->size=sizeof(prec->s09v);
  pdbRecordType->papFldDes[223]->offset=(short)((char *)&prec->s09v - (char *)prec);
  pdbRecordType->papFldDes[224]->size=sizeof(prec->s09l);
  pdbRecordType->papFldDes[224]->offset=(short)((char *)&prec->s09l - (char *)prec);
  pdbRecordType->papFldDes[225]->size=sizeof(prec->s09o);
  pdbRecordType->papFldDes[225]->offset=(short)((char *)&prec->s09o - (char *)prec);
  pdbRecordType->papFldDes[226]->size=sizeof(prec->s10v);
  pdbRecordType->papFldDes[226]->offset=(short)((char *)&prec->s10v - (char *)prec);
  pdbRecordType->papFldDes[227]->size=sizeof(prec->s10l);
  pdbRecordType->papFldDes[227]->offset=(short)((char *)&prec->s10l - (char *)prec);
  pdbRecordType->papFldDes[228]->size=sizeof(prec->s10o);
  pdbRecordType->papFldDes[228]->offset=(short)((char *)&prec->s10o - (char *)prec);
  pdbRecordType->papFldDes[229]->size=sizeof(prec->s11v);
  pdbRecordType->papFldDes[229]->offset=(short)((char *)&prec->s11v - (char *)prec);
  pdbRecordType->papFldDes[230]->size=sizeof(prec->s11l);
  pdbRecordType->papFldDes[230]->offset=(short)((char *)&prec->s11l - (char *)prec);
  pdbRecordType->papFldDes[231]->size=sizeof(prec->s11o);
  pdbRecordType->papFldDes[231]->offset=(short)((char *)&prec->s11o - (char *)prec);
  pdbRecordType->papFldDes[232]->size=sizeof(prec->s12v);
  pdbRecordType->papFldDes[232]->offset=(short)((char *)&prec->s12v - (char *)prec);
  pdbRecordType->papFldDes[233]->size=sizeof(prec->s12l);
  pdbRecordType->papFldDes[233]->offset=(short)((char *)&prec->s12l - (char *)prec);
  pdbRecordType->papFldDes[234]->size=sizeof(prec->s12o);
  pdbRecordType->papFldDes[234]->offset=(short)((char *)&prec->s12o - (char *)prec);
  pdbRecordType->papFldDes[235]->size=sizeof(prec->s13v);
  pdbRecordType->papFldDes[235]->offset=(short)((char *)&prec->s13v - (char *)prec);
  pdbRecordType->papFldDes[236]->size=sizeof(prec->s13l);
  pdbRecordType->papFldDes[236]->offset=(short)((char *)&prec->s13l - (char *)prec);
  pdbRecordType->papFldDes[237]->size=sizeof(prec->s13o);
  pdbRecordType->papFldDes[237]->offset=(short)((char *)&prec->s13o - (char *)prec);
  pdbRecordType->papFldDes[238]->size=sizeof(prec->s14v);
  pdbRecordType->papFldDes[238]->offset=(short)((char *)&prec->s14v - (char *)prec);
  pdbRecordType->papFldDes[239]->size=sizeof(prec->s14l);
  pdbRecordType->papFldDes[239]->offset=(short)((char *)&prec->s14l - (char *)prec);
  pdbRecordType->papFldDes[240]->size=sizeof(prec->s14o);
  pdbRecordType->papFldDes[240]->offset=(short)((char *)&prec->s14o - (char *)prec);
  pdbRecordType->papFldDes[241]->size=sizeof(prec->strt);
  pdbRecordType->papFldDes[241]->offset=(short)((char *)&prec->strt - (char *)prec);
  pdbRecordType->papFldDes[242]->size=sizeof(prec->stop);
  pdbRecordType->papFldDes[242]->offset=(short)((char *)&prec->stop - (char *)prec);
  pdbRecordType->papFldDes[243]->size=sizeof(prec->eras);
  pdbRecordType->papFldDes[243]->offset=(short)((char *)&prec->eras - (char *)prec);
  pdbRecordType->papFldDes[244]->size=sizeof(prec->t01v);
  pdbRecordType->papFldDes[244]->offset=(short)((char *)&prec->t01v - (char *)prec);
  pdbRecordType->papFldDes[245]->size=sizeof(prec->t01l);
  pdbRecordType->papFldDes[245]->offset=(short)((char *)&prec->t01l - (char *)prec);
  pdbRecordType->papFldDes[246]->size=sizeof(prec->t02v);
  pdbRecordType->papFldDes[246]->offset=(short)((char *)&prec->t02v - (char *)prec);
  pdbRecordType->papFldDes[247]->size=sizeof(prec->t02l);
  pdbRecordType->papFldDes[247]->offset=(short)((char *)&prec->t02l - (char *)prec);
  pdbRecordType->papFldDes[248]->size=sizeof(prec->t03v);
  pdbRecordType->papFldDes[248]->offset=(short)((char *)&prec->t03v - (char *)prec);
  pdbRecordType->papFldDes[249]->size=sizeof(prec->t03l);
  pdbRecordType->papFldDes[249]->offset=(short)((char *)&prec->t03l - (char *)prec);
  pdbRecordType->papFldDes[250]->size=sizeof(prec->t04v);
  pdbRecordType->papFldDes[250]->offset=(short)((char *)&prec->t04v - (char *)prec);
  pdbRecordType->papFldDes[251]->size=sizeof(prec->t04l);
  pdbRecordType->papFldDes[251]->offset=(short)((char *)&prec->t04l - (char *)prec);
  pdbRecordType->papFldDes[252]->size=sizeof(prec->t05v);
  pdbRecordType->papFldDes[252]->offset=(short)((char *)&prec->t05v - (char *)prec);
  pdbRecordType->papFldDes[253]->size=sizeof(prec->t05l);
  pdbRecordType->papFldDes[253]->offset=(short)((char *)&prec->t05l - (char *)prec);
  pdbRecordType->papFldDes[254]->size=sizeof(prec->t06v);
  pdbRecordType->papFldDes[254]->offset=(short)((char *)&prec->t06v - (char *)prec);
  pdbRecordType->papFldDes[255]->size=sizeof(prec->t06l);
  pdbRecordType->papFldDes[255]->offset=(short)((char *)&prec->t06l - (char *)prec);
  pdbRecordType->papFldDes[256]->size=sizeof(prec->t07v);
  pdbRecordType->papFldDes[256]->offset=(short)((char *)&prec->t07v - (char *)prec);
  pdbRecordType->papFldDes[257]->size=sizeof(prec->t07l);
  pdbRecordType->papFldDes[257]->offset=(short)((char *)&prec->t07l - (char *)prec);
  pdbRecordType->papFldDes[258]->size=sizeof(prec->t08v);
  pdbRecordType->papFldDes[258]->offset=(short)((char *)&prec->t08v - (char *)prec);
  pdbRecordType->papFldDes[259]->size=sizeof(prec->t08l);
  pdbRecordType->papFldDes[259]->offset=(short)((char *)&prec->t08l - (char *)prec);
  pdbRecordType->papFldDes[260]->size=sizeof(prec->t09v);
  pdbRecordType->papFldDes[260]->offset=(short)((char *)&prec->t09v - (char *)prec);
  pdbRecordType->papFldDes[261]->size=sizeof(prec->t09l);
  pdbRecordType->papFldDes[261]->offset=(short)((char *)&prec->t09l - (char *)prec);
  pdbRecordType->papFldDes[262]->size=sizeof(prec->t10v);
  pdbRecordType->papFldDes[262]->offset=(short)((char *)&prec->t10v - (char *)prec);
  pdbRecordType->papFldDes[263]->size=sizeof(prec->t10l);
  pdbRecordType->papFldDes[263]->offset=(short)((char *)&prec->t10l - (char *)prec);
  pdbRecordType->papFldDes[264]->size=sizeof(prec->t11v);
  pdbRecordType->papFldDes[264]->offset=(short)((char *)&prec->t11v - (char *)prec);
  pdbRecordType->papFldDes[265]->size=sizeof(prec->t11l);
  pdbRecordType->papFldDes[265]->offset=(short)((char *)&prec->t11l - (char *)prec);
  pdbRecordType->papFldDes[266]->size=sizeof(prec->rcal);
  pdbRecordType->papFldDes[266]->offset=(short)((char *)&prec->rcal - (char *)prec);
  pdbRecordType->papFldDes[267]->size=sizeof(prec->calr);
  pdbRecordType->papFldDes[267]->offset=(short)((char *)&prec->calr - (char *)prec);
  pdbRecordType->papFldDes[268]->size=sizeof(prec->pktm);
  pdbRecordType->papFldDes[268]->offset=(short)((char *)&prec->pktm - (char *)prec);
  pdbRecordType->papFldDes[269]->size=sizeof(prec->pkl);
  pdbRecordType->papFldDes[269]->offset=(short)((char *)&prec->pkl - (char *)prec);
  pdbRecordType->papFldDes[270]->size=sizeof(prec->inp);
  pdbRecordType->papFldDes[270]->offset=(short)((char *)&prec->inp - (char *)prec);
    pdbRecordType->rec_size = sizeof(*prec);
    return(0);
}
#endif /*GEN_SIZE_OFFSET*/
